#include "ChatMsgThread.h"
#include "MySyncObject.h"
#include "SendRecvThread.h"
#include "RingBuff.h"



CChatMsgThread::CChatMsgThread(CSendRecvThread *pCSendRecvThread)
{
	// p[^L
	m_pCSendRecvThread = pCSendRecvThread;

	// ϐ̏
	m_fIamZombie = FALSE;

	m_pCRingBuffCmd = new CRingBuff(CMD_BUFF_SIZE);					// R}hi[p
	m_pCRingBuffForDistributeChat = new CRingBuff(RECV_BUFF_SIZE);	// `bgzMpOobt@̍\z
	m_pCMySyncObject = new CMySyncObject();
	m_pCMySyncObject->Initialize();
}


CChatMsgThread::~CChatMsgThread()
{
	if (m_pCMySyncObject != NULL)
		m_pCMySyncObject->Uninitialize();
	SAFE_DELETE(m_pCMySyncObject)
	SAFE_DELETE(m_pCRingBuffCmd)
	SAFE_DELETE(m_pCRingBuffForDistributeChat)		// `bgzMpOobt@̔j
}


UINT CChatMsgThread::DoWork()
{
	BOOL		fRet = TRUE;

	while (!m_fStopFlag)
	{
		Sleep(10);					// Sleepđ̃XbhɃ`X^
		if (AnalyzeCmd() == -1)		// Ԓl-1̎G[ÃXbh]rɂ
		{
			fRet = FALSE;
			break;
		}
	}
	m_pCMySyncObject->Lock();
	m_fIamZombie = TRUE;
	m_pCMySyncObject->UnLock();
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		bZ[WR}h̉
// parameter
//		Ȃ
// retun
//		0:\ȃf[^i[ĂȂȂ 1:͐ -1:͎s
//----------------------------------------------
int CChatMsgThread::AnalyzeCmd()
{
	int			iRet = 0;
	HeaderRec	Header;
	WORD		wCmd;
	int			iSize = m_pCRingBuffCmd->GetReadableSize();
	int			iPacketSize, iDataSize;
	LPBYTE		pbPacket = NULL;

	if (iSize < sizeof(HeaderRec))			// wb_TCYɖȂƂ͉Ȃ
		goto L_END;

	// wb_؂ǂݍ݂(pPbgۂƊi[Ă͂ł)
	m_pCRingBuffCmd->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
	wCmd = ntohs(Header.wCommand);
	iDataSize = ntohs(Header.wDataLen);
	iPacketSize = iDataSize + sizeof(HeaderRec);
	if (iSize < iPacketSize)				// pPbgTCYɖȂƂ͉Ȃ
		goto L_END;

	pbPacket = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	// pPbgŜǂ
	m_pCRingBuffCmd->Read(pbPacket, iPacketSize);

	switch (wCmd)
	{
		case CMD_MSG_DATA:
			iRet = RecvMessagePacket((MsgDataRec *)pbPacket);
			break;
		default:
			iRet = -1;							// mȂR}h
			break;
	}
L_END:
	SAFE_FREE(pbPacket)
	return(iRet);
}

//----------------------------------------------
// function
//		bZ[WR}h̎M
// parameter
//		 MsgDataRec *pbPacket	[in]bZ[WpPbg
// return
//		0:pPbgĂȂ
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
int CChatMsgThread::RecvMessagePacket(MsgDataRec *pbPacket)
{
	int			iRet = 0;
	int			iMsgSize, iSize;
	char		*pszMsg = NULL;
	LPBYTE		pbDest = NULL;

	iMsgSize = ntohs(pbPacket->header.wDataLen);
	// NULL^[~l[gǉĊm
	pszMsg = (char *)calloc(iMsgSize + 1, sizeof(char));
	memcpy(pszMsg, pbPacket->bMsgData, iMsgSize);

	// `bgM̂߂ɃbZ[Wf[^pPbgăZbg
	SendMessagePacket(pszMsg, iMsgSize);

	// UTF-8ŎM̂ŁASJISɕϊĕ\
	ConvUtf8toSJis((LPBYTE)pszMsg, NULL, &iSize);
	pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
	ConvUtf8toSJis((LPBYTE)pszMsg, pbDest, &iSize);

	Locate(12, 10, 1);
	fprintf(stderr, "Msg:recv %s\n", pbDest);

	SAFE_FREE(pszMsg)
	SAFE_FREE(pbDest)
	iRet = 1;
	return(iRet);
}

//----------------------------------------------
// function
//		bZ[WpPbg̑M
//		`bgbZ[WNCAgɓ]邽߂̃GA
//		i[
// parameter
//		char	*pcData		[in]UTF-8f[^(NULL^[~l[gȂ)
//		int		iSize		[in]f[^TCY
// retun
//		Ȃ
//----------------------------------------------
BOOL CChatMsgThread::SendMessagePacket(char *pcData, int iSize)
{
	MsgDataRec	*pMsgData = NULL;
	int			iPacketSize = sizeof(HeaderRec) + iSize;		// pPbgTCY
	BOOL		fRet = FALSE;

	pMsgData = (MsgDataRec *)calloc(iPacketSize, sizeof(BYTE));	// pPbgŜ̃GAm

	memcpy(pMsgData->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pMsgData->header.wCommand = htons(CMD_MSG_DATA);
	pMsgData->header.wDataLen = htons(iSize);

	memcpy(pMsgData->bMsgData, pcData, iSize);
	// `bgM̂߂ɃbZ[WpPbgf[^Zbg
	fRet = SetDataForDistributeChat((char *)pMsgData, iPacketSize);

	SAFE_FREE(pMsgData)
	return(fRet);
}

//----------------------------------------------
// function
//		`bgbZ[WNCAgɕz邽߂Ɋi[
// parameter
//		char	*pcData	[in]`bgbZ[WpPbg
//		int		iSize	[in]pPbg
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CChatMsgThread::SetDataForDistributeChat(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	// i[pOobt@ɋ󂫂ȂƂ͏܂Ȃ
	fRet = m_pCRingBuffForDistributeChat->Write((LPBYTE)pcData, iSize);
	return(fRet);
}


//----------------------------------------------
// function
//		`bgzpf[^̎擾
//		pPbgPʂŎo
//		͂PpPbg
// parameter
//		char **ppcData	[in/out]`bg]pf[^
// return
//		f[^
//----------------------------------------------
int CChatMsgThread::GetDataForDistributeChat(char **ppcData)
{
	int			iSize = 0, iStoreSize, iPacketSize;
	HeaderRec	Header;

	if ((iStoreSize = m_pCRingBuffForDistributeChat->GetReadableSize()) >= sizeof(HeaderRec))
	{
		// wb_ǂݍ݂
		m_pCRingBuffForDistributeChat->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
		iPacketSize = ntohs(Header.wDataLen) + sizeof(HeaderRec);
		if (iStoreSize >= iPacketSize)
		{
			*ppcData = (char *)calloc(iPacketSize, sizeof(char));
			iSize = m_pCRingBuffForDistributeChat->Read((LPBYTE)*ppcData, iPacketSize);
		}
	}
	return(iSize);
}


//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CChatMsgThread::IsZombie()
{
	BOOL	fRet;

	m_pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pCMySyncObject->UnLock();
	return(fRet);
}

