#include "RecvFileThread.h"
#include "MySyncObject.h"
#include "SendRecvThread.h"
#include "RingBuff.h"

CRecvFileThread::CRecvFileThread(CSendRecvThread *pCSendRecvThread)
{
	// p[^L
	m_pCSendRecvThread = pCSendRecvThread;

	// ϐ̏
	m_fIamZombie = FALSE;
	m_fdDstFile = -1;							// t@CfBXNv^
	m_iRecvFileStatus = RECV_FILE_STAT_IDLE;	// t@CMR}h̑J
	memset(m_szFileName, 0, sizeof(m_szFileName)); // t@C폜̂߂̃t@C̏

	m_pCRingBuffCmd = new CRingBuff(CMD_BUFF_SIZE);	// t@CMR}hi[p
	m_pCMySyncObject = new CMySyncObject();
	m_pCMySyncObject->Initialize();
}


CRecvFileThread::~CRecvFileThread()
{
	if (m_pCMySyncObject != NULL)
		m_pCMySyncObject->Uninitialize();
	SAFE_DELETE(m_pCMySyncObject)
	SAFE_DELETE(m_pCRingBuffCmd)
// I[v܂܂̃t@C΂̂ŃN[YA폜
	if (m_fdDstFile != -1)
	{
		_close(m_fdDstFile);
		_unlink(m_szFileName);
	}
	m_fdDstFile = -1;
}

UINT CRecvFileThread::DoWork()
{
	BOOL		fRet = TRUE;

	while (!m_fStopFlag)
	{
		Sleep(10);					// Sleepđ̃XbhɃ`X^
		if (AnalyzeCmd() == -1)		// Ԓl-1̎G[ÃXbh]rɂ
		{
			fRet = FALSE;
			break;
		}
	}
	m_pCMySyncObject->Lock();
	m_fIamZombie = TRUE;
	m_pCMySyncObject->UnLock();
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		t@CMR}h̉
// parameter
//		Ȃ
// retun
//		0:\ȃf[^i[ĂȂȂ 1:͐ -1:͎s
//----------------------------------------------
int CRecvFileThread::AnalyzeCmd()
{
	int			iRet = 0;
	HeaderRec	Header;
	WORD		wCmd;
	int			iSize = m_pCRingBuffCmd->GetReadableSize();
	int			iPacketSize, iDataSize;
	LPBYTE		pbPacket = NULL;

	if (iSize < sizeof(HeaderRec))			// wb_TCYɖȂƂ͉Ȃ
		goto L_END;

	// wb_؂ǂݍ݂(pPbgۂƊi[Ă͂ł)
	m_pCRingBuffCmd->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
	wCmd = ntohs(Header.wCommand);
	iDataSize = ntohs(Header.wDataLen);
	iPacketSize = iDataSize + sizeof(HeaderRec);
	if (iSize < iPacketSize)				// pPbgTCYɖȂƂ͉Ȃ
		goto L_END;

	pbPacket = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	// pPbgŜǂ
	m_pCRingBuffCmd->Read(pbPacket, iPacketSize);

	switch (wCmd)
	{
		case CMD_SEND_FILE_START_REQ:			// @MJnvM
			iRet = RecvSendFileStartPacket((SendFileStartReqRec *)pbPacket);
			break;
		case CMD_SEND_FILE_ING:					// At@CM
			iRet = RecvSendFileIngPacket((SendFileIngRec *)pbPacket);
			break;
		case CMD_SEND_FILE_END_REQ:				// BMvM
			iRet = RecvSendFileEndPacket((SendFileEndReqRec *)pbPacket);
			break;
		case CMD_SEND_FILE_ABORT_REQ:			// MfvM
			iRet = RecvSendFileAbortPacket((SendFileAbortReqRec *)pbPacket);
			break;
		default:
			iRet = -1;							// mȂR}h
			break;
	}
L_END:
	SAFE_FREE(pbPacket)
	return(iRet);
}

//----------------------------------------------
// function
//		@t@CMJnR}h̎M
// parameter
//		 SendFileStartReqRec *pbPacket	[in]t@CMJnR}hpPbg
// return
//		1:͐ -1:vIG[
//----------------------------------------------
int CRecvFileThread::RecvSendFileStartPacket(SendFileStartReqRec *pbPacket)
{
	int			iRet = 0, iSize;
	LPBYTE		pbDest = NULL;

	if (m_iRecvFileStatus != RECV_FILE_STAT_IDLE)
	{
		iRet = -1;						// JڏԃG[͐ؒf
		goto L_END;
	}
	// UTF-8ŎM̂ŁASJISɕϊ
	ConvUtf8toSJis((LPBYTE)pbPacket->FileInfo.szFileName, NULL, &iSize);
	pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
	ConvUtf8toSJis((LPBYTE)pbPacket->FileInfo.szFileName, pbDest, &iSize);

	Locate(1, 11, 2);
	fprintf(stderr, "t@CM %s %s(%u)",  (LPSTR)pbDest, pbPacket->FileInfo.szFileSize, timeGetTime());

	// ŏݗpɃt@Copen
	DISABLE_C4996
	m_fdDstFile = _open((LPSTR)pbDest, _O_CREAT | _O_WRONLY | _O_TRUNC | _O_BINARY, _S_IREAD | _S_IWRITE);
	ENABLE_C4996
	if(m_fdDstFile == -1)
	{
		SendSendFileStartResPacket(-1);		// G[𑗐M
		goto L_END;
	}
	// Jnt@Co
	DISABLE_C4996
	strcpy(m_szFileName, (LPSTR)pbDest);
	ENABLE_C4996
	m_iRecvFileStatus = RECV_FILE_STAT_ING;
	m_pCRingBuffCmd->Clear();				// t@CMR}hobt@ɂ
	SendSendFileStartResPacket(1);			// OK𑗐M
	iRet = 1;
L_END:
	if (iRet == -1)					// G[I[vĂt@C΃N[YA폜
	{
		if (m_fdDstFile != -1)
		{
			_close(m_fdDstFile);
			_unlink(m_szFileName);
		}
		m_fdDstFile = -1;
	}
	SAFE_FREE(pbDest)
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMJnvɑ΂鉞𑗐M
// parameter
//		char cResCode	[in]R[h 1/-1
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::SendSendFileStartResPacket(char cResCode)
{
	BOOL	fRet = FALSE;
	SendFileResRec	*pSendFileStartRes = NULL;
	int		iPacketSize;

	iPacketSize = sizeof(SendFileResRec);
	pSendFileStartRes = (SendFileResRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pSendFileStartRes->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pSendFileStartRes->header.wCommand = htons(CMD_SEND_FILE_START_RES);
	pSendFileStartRes->header.wDataLen = htons(sizeof(char));

	pSendFileStartRes->cResCode = cResCode;

	fRet = m_pCSendRecvThread->SetSendData((char *)pSendFileStartRes, iPacketSize);
	SAFE_FREE(pSendFileStartRes)

	return(fRet);
}

//----------------------------------------------
// function
//		t@CMR}h̎M
// parameter
//		 SendFileIngRec *pbPacket[in]t@CMR}hpPbg
// return
//		0:\ȃf[^i[ĂȂ 1:͐ -1:͎s
//----------------------------------------------
int CRecvFileThread::RecvSendFileIngPacket(SendFileIngRec *pbPacket)
{
	int			iRet = 0;
	long		lDataSize, lOffset;

	Locate(1, 12, 1);
	fprintf(stderr, "t@CM %s %s", pbPacket->Stat.szOffset, pbPacket->Stat.szSize);

	if (m_iRecvFileStatus != RECV_FILE_STAT_ING)
	{
		iRet = -1;				// JڏԃG[͐ؒf
		goto L_END;
	}
	lDataSize = atol(pbPacket->Stat.szSize);
	lOffset = atol(pbPacket->Stat.szOffset);
	if (lDataSize > 0)
	{
		// t@C쎸sG[ƂĐؒf
		if (_lseek(m_fdDstFile, lOffset, SEEK_SET) == -1)
		{
			iRet = -1;
			goto L_END;
		}
		if (_write(m_fdDstFile, pbPacket->bData, lDataSize) != lDataSize)
		{
			iRet = -1;
			goto L_END;
		}
	}
	iRet = 1;
L_END:
	if (iRet == -1)				// G[I[vĂt@C΃N[YA폜
	{
		if (m_fdDstFile != -1)
		{
			_close(m_fdDstFile);
			_unlink(m_szFileName);
		}
		m_fdDstFile = -1;
	}
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMIR}h̎M
// parameter
//		 SendFileEndReqRec *pbPacket 	[in]t@CMIR}hpPbg
// return
//		0:\ȃf[^i[ĂȂ 1:͐ -1:͎s
//----------------------------------------------
int CRecvFileThread::RecvSendFileEndPacket(SendFileEndReqRec *pbPacket)
{
	int			iRet = 0;
	long		lDataSize, lOffset;

	Locate(1, 13, 1);
	fprintf(stderr, "t@CM %s %s(%u)", pbPacket->Stat.szOffset, pbPacket->Stat.szSize, timeGetTime());

	if (m_iRecvFileStatus != RECV_FILE_STAT_ING)
	{
		iRet = -1;				// JڏԃG[͐ؒf
		goto L_END;
	}
	lDataSize = atol(pbPacket->Stat.szSize);
	lOffset = atol(pbPacket->Stat.szOffset);
	if (lDataSize > 0)
	{
		// t@C쎸sG[ƂĐؒf
		if (_lseek(m_fdDstFile, lOffset, SEEK_SET) == -1)
		{
			iRet = -1;
			goto L_END;
		}
		if (_write(m_fdDstFile, pbPacket->bData, lDataSize) != lDataSize)
		{
			iRet = -1;
			goto L_END;
		}
	}
	iRet = 1;
	SendSendFileEndResPacket(1);		// MvM
L_END:
	if (m_fdDstFile != -1)
	{
		_close(m_fdDstFile);
		if(iRet == -1)					// G[폜
			_unlink(m_szFileName);
	}
	m_iRecvFileStatus = RECV_FILE_STAT_IDLE;
	m_fdDstFile = -1;
	return(iRet);
}


//----------------------------------------------
// function
//		t@CMvɑ΂鉞𑗐M
// parameter
//		char cResCode	[in]R[h 1/-1
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::SendSendFileEndResPacket(char cResCode)
{
	BOOL	fRet = FALSE;
	SendFileResRec	*pSendFileEndRes = NULL;
	int		iPacketSize;

	iPacketSize = sizeof(SendFileResRec);
	pSendFileEndRes = (SendFileResRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pSendFileEndRes->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pSendFileEndRes->header.wCommand = htons(CMD_SEND_FILE_END_RES);
	pSendFileEndRes->header.wDataLen = htons(sizeof(char));

	pSendFileEndRes->cResCode = cResCode;

	fRet = m_pCSendRecvThread->SetSendData((char *)pSendFileEndRes, iPacketSize);
	SAFE_FREE(pSendFileEndRes)

	return(fRet);
}

//----------------------------------------------
// function
//		t@CMfR}h̎M
// parameter
//		 SendFileAbortReqRec *pbPacket 	[in]t@CMfR}hpPbg
// return
//		0:\ȃf[^i[ĂȂ 1:͐ -1:͎s
//----------------------------------------------
int CRecvFileThread::RecvSendFileAbortPacket(SendFileAbortReqRec *pbPacket)
{
	int			iRet = 0;

	m_iRecvFileStatus = RECV_FILE_STAT_ABORT;
	Locate(1, 13, 1);
	fprintf(stderr, "t@CMf");

	iRet = 1;
	SendSendFileAbortResPacket(1);		// MfvM

	if (m_fdDstFile != -1)
	{
		_close(m_fdDstFile);
		_unlink(m_szFileName);
	}
	m_fdDstFile = -1;
	m_iRecvFileStatus = RECV_FILE_STAT_IDLE;
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMfvɑ΂鉞𑗐M
// parameter
//		char cResCode	[in]R[h 1/-1
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::SendSendFileAbortResPacket(char cResCode)
{
	BOOL	fRet = FALSE;
	SendFileResRec	*pSendFileAbortRes = NULL;
	int		iPacketSize;

	iPacketSize = sizeof(SendFileResRec);
	pSendFileAbortRes = (SendFileResRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pSendFileAbortRes->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pSendFileAbortRes->header.wCommand = htons(CMD_SEND_FILE_ABORT_RES);
	pSendFileAbortRes->header.wDataLen = htons(sizeof(char));
	pSendFileAbortRes->cResCode = cResCode;

	fRet = m_pCSendRecvThread->SetSendData((char *)pSendFileAbortRes, iPacketSize);
	SAFE_FREE(pSendFileAbortRes)
	return(fRet);
}

//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CRecvFileThread::IsZombie()
{
	BOOL	fRet;

	m_pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pCMySyncObject->UnLock();
	return(fRet);
}
